
// Persistence of Vision Ray Tracer Scene Description File
// File: .pov
// Vers: 3
// Desc:
// Date:
// Auth: NB
/*
background{ color rgb <.9,.9,1>}

light_source {<-500,-500,-500>
color rgb <1,1,1>}

//camera{ location<-60,-10,0>*3
camera{ location<0,-10,-60>*3
//camera{ location<0,-60,0>*3
//camera{ location<500,50,300>*.5
angle 5
look_at <0,-10,0>}
//look_at <0,0,0>}

#declare DD_TEX =
texture{
   finish{
   diffuse .4
      ambient <1,.85,.7>*.8
      phong 0.2
      phong_size 20
   }
   pigment{color rgb <.7,1,.6>}
}

#declare SIDE = 1 // 1=left, -1=right, don't even try other values
*/
#declare HR_02 = .65
#declare HS_02 = 3
#declare HD_02 = HS_02*pow((1-pow(HR_02,2)),2)
#declare LB_01 = 11
#declare LAX_01 = 7
#declare LAX_02 = 2
#declare LAZ_01 = 2
#declare LB_02 = 10.7
/*
#declare ZCENT = 3.05*SIDE

#declare LJZ_01 = -30
#declare LJZ_02 = 40
#declare LJZ_03 = 0//20
*/
union {
    union {
	cylinder {
	    <0,0,0>,
	    <0,0.1,0>, 1
	    scale <2.3,1,1.3>
	}
	difference {
	    torus { 1,0.1 rotate z*90 translate y*0.3 }
	    plane { y,0 }
	    scale <2,0.7,1>
	    translate <-1,0,0>
	}
	difference {
	    torus { 1,0.1 rotate z*90 translate y*0.3 }
	    plane { y,0 }
	    scale <2,1.1,1.2>
	    translate <-0.1,-0.3,0>
	}

	// These transformations are REALLY accumulating!
	rotate y*-15
	translate <+0.2,-1.5,0>
	rotate z*20
    }
    cone {
	<0,0,0>,0.9
	<0,4,0>,1.0
	translate <2,0,0>
	texture {
	    quilted
	    control0 1
	    texture_map {
		[ 0 pigment { Clear } ]
		[ 0.3 pigment { Clear } ]
		[ 0.3 SANDLE_TEXTURE ]
		[ 1.0 SANDLE_TEXTURE ]
	    }
	    rotate x*45
	}
	rotate z*-4
    }
    translate y*-3
    translate <-2,2.95,0>

    rotate z*(LJZ_03-20)
    translate y*LB_02*-1
    rotate x*(LAX_02*SIDE)*-1
    rotate z*LJZ_02
    translate <LB_01*cos(radians(LAX_01))*sin(radians(LAZ_01))*SIDE,
             (LB_01*cos(radians(LAX_01))*cos(radians(LAZ_01))*SIDE)*-1,
              LB_01*sin(radians(LAX_01))>*SIDE
    rotate z*LJZ_01  rotate x*LJX_01
    translate y*10
    translate z*ZCENT*-1
    texture { SANDLE_TEXTURE }
}
